<template>
  <div class="app-container">
    <!--    搜索栏-->
    <el-form v-show="showSearch" ref="queryRef" :inline="true" :label-width=" locale ? '100px':'140px'"
             :model="queryParams">
      <el-form-item :label="t('baseCar.carType.title')" prop="title">
        <el-input
            v-model="queryParams.title"
            :placeholder="t('common.pleaseEnter') + t('baseCar.carType.title')"
            clearable
            style="width: 200px"
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label=" ">
        <el-button icon="Search" type="primary" @click="handleQuery">{{ t('option.search') }}</el-button>
        <el-button icon="Refresh" @click="resetQuery">{{ t('option.reset') }}</el-button>
      </el-form-item>
    </el-form>

    <!--    顶部操作按钮-->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
            v-hasPermi="['cartype:cartype:add']"
            icon="Plus"
            plain
            type="primary"
            @click="handleAdd"
        >{{ t('option.add') }}
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            v-hasPermi="['cartype:cartype:edit']"
            :disabled="single"
            icon="Edit"
            plain
            type="success"
            @click="handleUpdate"
        >{{ t('option.edit') }}
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            v-hasPermi="['cartype:cartype:remove']"
            :disabled="multiple"
            icon="Delete"
            plain
            type="danger"
            @click="handleDelete"
        >{{ t('option.remove') }}
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            v-hasPermi="['cartype:cartype:export']"
            icon="Download"
            plain
            type="warning"
            @click="handleExport"
        >{{ t('option.export') }}
        </el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!--    表格主体-->
    <el-table v-loading="loading" :data="postList" @selection-change="handleSelectionChange">
      <el-table-column :label="t('baseCar.carType.title')" align="center" prop="title"/>
      <el-table-column :label="t('baseCar.carType.state')" align="center" prop="state"
                       width="150"/>
      <el-table-column :label="t('baseCar.carType.axleTotal')" align="center" prop="axleTotal"
                       width="150"/>
      <el-table-column :label="t('common.createTime')" align="center" prop="createTime"/>
      <el-table-column :label="t('common.createBy')" align="center" prop="createBy"/>
      <el-table-column :label="t('option.option')" align="center" class-name="small-padding fixed-width" fixed="right"
                       width="160">
        <template #default="scope">
          <el-button
              v-hasPermi="['cartype:cartype:edit']"
              icon="Edit"
              type="text"
              @click="handleUpdate(scope.row)"
          >{{ t('option.edit') }}
          </el-button>
          <el-button
              v-hasPermi="['cartype:cartype:remove']"
              icon="Delete"
              type="text"
              @click="handleDelete(scope.row)"
          >{{ t('option.remove') }}
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <!--    分页-->
    <pagination
        v-show="total > 0"
        v-model:limit="queryParams.pageSize"
        v-model:page="queryParams.pageNum"
        :total="total"
        @pagination="getList"
    />

    <!-- 添加或修改岗位对话框 -->
    <el-dialog v-model="open" :title="title" append-to-body width="80vw">
      <el-form ref="postRef" :inline="true" :label-width=" locale ?  '100px':'140px'" :model="form"
               :rules="rules">
        <el-form-item label="轮胎排数" prop="axleTotal">
          <el-select v-model="form.axleTotal" placeholder="Select" size="large" @change="TireRowChange">
            <el-option
                v-for="item in TireRow"
                :key="item.value"
                :label="item.label"
                :value="item.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="是否启用" prop="state">
          <el-switch v-model="form.state"/>
        </el-form-item>
      </el-form>
      <div style="width: 100%;text-align: center;height: 50px;line-height: 50px">轮胎布局图</div>
      <div style="width: 100%;height: 80px;background-color: #eee">
        <el-select v-for="(item,index) in TireRowInfo"
                   v-model="TireRowInfo[index]"
                   :style='"width:calc((80vw - 40px)/"+TireRowInfo.length+" );padding:20px"'
                   placeholder="Select" size="large">
          <el-option
              v-for="item in TireRowOptions"
              :key="item.value"
              :label="item.label"
              :value="item.value"
          />
        </el-select>
      </div>
      <div style="margin-top: 4px">
        <div style="width: 100%;height: 80px;background-color: #eee">
          <div
              v-for="(item,index) in TireRowInfo"
              :style='"width:calc((80vw - 40px)/"+TireRowInfo.length+" );padding:4px 20px;display:inline-block;text-align:center"'>
            <img alt="" src="@/assets/images/tyre.png">
          </div>
        </div>
        <div style="width: 100%;height: auto;background-color: #eee">
          <div
              v-for="(item,index) in TireRowInfo"
              :style='"width:calc((80vw - 40px)/"+TireRowInfo.length+" );padding:4px 20px;display:inline-block;text-align:center"'>
            <img v-if="TireRowInfo[index] === 2" alt="" src="@/assets/images/tyre.png">
          </div>
        </div>
      </div>
      <div style="margin-top: 16px">
        <div style="width: 100%;height: 80px;background-color: #eee;">
          <div
              v-for="(item,index) in TireRowInfo"
              :style='"width:calc((80vw - 40px)/"+TireRowInfo.length+" );padding:4px 20px;display:inline-block;text-align:center"'>
            <img alt="" src="@/assets/images/tyre.png">
          </div>
        </div>
        <div style="width: 100%;height: auto;background-color: #eee">
          <div
              v-for="(item,index) in TireRowInfo"
              :style='"width:calc((80vw - 40px)/"+TireRowInfo.length+" );padding: 4px 20px;display:inline-block;text-align:center"'>
            <img v-if="TireRowInfo[index] === 2" alt="" src="@/assets/images/tyre.png">
          </div>
        </div>
      </div>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">{{ t('option.ok') }}</el-button>
          <el-button @click="cancel">{{ t('option.cancel') }}</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script name="basetyre" setup>
import {addCartype, delCartype, getCartype, listCartype, updateCartype} from "@/api/basecar/cartype";

import {useI18n} from 'vue-i18n';
import Cookies from "js-cookie";

const {t} = useI18n();

const locale = (Cookies.get('language') || 'zhCn') === 'zhCn'
const {proxy} = getCurrentInstance();
const {sys_normal_disable} = proxy.useDict("sys_normal_disable");


// 表格数据
const postList = ref([]);
// 模态框开关标识
const open = ref(false);
// 表格加载状态开关标识
const loading = ref(true);
// 搜索区域开关标识
const showSearch = ref(true);
// 选择行id
const ids = ref([]);
// 修改按钮是否可用标识
const single = ref(true);
// 删除按钮是否可用标识
const multiple = ref(true);
// 总条数
const total = ref(0);
// 模态框标题
const title = ref("");
// 轮胎排数
const TireRow = [
  {
    value: 1,
    label: '一排'
  },
  {
    value: 2,
    label: '二排'
  },
  {
    value: 3,
    label: '三排'
  },
  {
    value: 4,
    label: '四排'
  },
  {
    value: 5,
    label: '五排'
  },
  {
    value: 6,
    label: '六排'
  },
]
// 轮胎排数信息
const TireRowInfo = ref([
  1, 1
])

const TireRowOptions = [
  {
    label: '单胎',
    value: 1
  },
  {
    label: '双胎',
    value: 2
  }
]

const TireRowChange = () => {
  let arr = []
  arr.length = form.value.axleTotal
  arr.fill(1)
  TireRowInfo.value = arr
}

// 搜索参数
const queryParams = ref({
  pageNum: 1,
  pageSize: 10,
  tyreFacCode: undefined,
  companyCode: undefined,
  code: undefined,
  title: undefined,
  state: undefined,
  axleTotal: undefined,
  tyreTotal: undefined,
  isDelete: undefined,
  createTime: undefined,
  createId: undefined,
  createBy: undefined,
  createName: undefined,
  modifyTime: undefined,
  modifyId: undefined,
  modifyBy: undefined,
  modifyName: undefined,
  trailerNum: undefined,
})

// 表单验证规则
const rules = {
  axleTotal: [{required: true, message: "请选择轮胎排数", trigger: "blur"}],
  type: [{required: true, message: "轮胎型号不能为空", trigger: "blur"}],
  serialNumber: [{required: true, message: "轮胎编号不能为空", trigger: "blur"}],
  depth: [{required: true, message: "花纹深度不能为空", trigger: "blur"}],
}

// 表单数据
const form = ref({
  id: null,
  axleTotal: 2,
  state: false,
});

/** 查询岗位列表 */
function getList() {
  loading.value = true;
  listCartype(queryParams.value).then(response => {
    postList.value = response.rows;
    total.value = response.total;
  }).finally(() => {
    loading.value = false;
  });
}

/** 取消按钮 */
function cancel() {
  open.value = false;
  reset();
}

/** 表单重置 */
function reset() {
  form.value = {
    id: null,
    axleTotal: 2,
    state: false,
  };
  TireRowInfo.value = [1, 1]
  proxy.resetForm("postRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
const resetQuery = () => {
  proxy.resetForm("queryRef");
  handleQuery();
}

/** 多选框选中数据 */
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id);
  single.value = selection.length !== 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = t('baseCar.carType.addTitle');
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const postId = row.id || ids.value;
  getCartype(postId).then(response => {
    let params = response.data
    params.state === 1 ? params.state = true : params.state = false
    let TireRow = params.title?.split('T')[1]?.split('|').filter(e => e !== '') || []
    let title = []
    TireRow.forEach((res) => {
      title.push(parseInt(res.split('-')[1]))
    })
    TireRowInfo.value = title
    form.value = params;
    open.value = true;
    title.value = t('baseCar.carType.editTitle');
  });
}

/** 提交按钮 */
function submitForm() {
  let title = (2 * TireRowInfo.value.reduce((a, b) => a + b)) + 'T' + TireRowInfo.value.map((e, index) => {
    return `${index + 1}-${e}|`
  }).join('')
  form.value.state ? form.value.state = 1 : form.value.state = 0
  let params = {...form.value, title}
  proxy.$refs["postRef"].validate(valid => {
    if (valid) {
      if (form.value.id != undefined) {
        updateCartype(params).then(response => {
          proxy.$modal.msgSuccess(t('option.modificationSuccessful'));
          open.value = false;
          getList();
        });
      } else {
        addCartype(params).then(response => {
          proxy.$modal.msgSuccess(t('option.addedSuccessfully'));
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const postIds = row.postId || ids.value;
  proxy.$modal.confirm(t('option.confirmDeletion', {
    key: t('baseCar.carType.tyreFacCode'), value: postIds
  })).then(function () {
    return delCartype(postIds);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess(t('option.successfullyDeleted'));
  }).catch(() => {
  });
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download("system/post/export", {
    ...queryParams.value
  }, `post_${new Date().getTime()}.xlsx`);
}

getList();
</script>
